/**
   ???
*/
var g_sDriver = "Global Cache";
var g_sHost = "192.168.0.89";
var g_nPort = 4998;
var g_nSendMode = 0;
var g_nScriptMode = 0;
var g_nDisableQueue = 0;
var g_nTrySendCount = 0;
var g_nBackGroundMode = 0;
var gKramerConnectID = 2;
var g_nSendCount = 0;
var g_nSerialPort1 = 4999;
var g_nSerialPort2 = 5000;
var g_nIrConfirm = 0;

/**
   ???
*/
IR.AddListener(IR.EVENT_START,0,function()
{
   UpdateParameters();
});

/**
   ???
*/
IR.AddListener(IR.EVENT_WORK,0,function()
{

});

/**
   ???
*/
IR.AddListener(IR.EVENT_EXIT,0,function()
{

});

/**
   ???
   на входе    :  ???
   на выходе   :  ???
*/
function Send()
{
   IR.GetDevice(g_sDriver).Send(['Hello' + g_nSendCount++ + '\r\n']);
}
/**
   ???
   на входе    :  ???
   на выходе   :  ???
*/
function UpdateParameters()
{
   IR.SetVariable("Global.DisableQueue", g_nDisableQueue);
   IR.SetVariable("Global.TrySendCount", g_nTrySendCount);
   IR.SetVariable("Global.AlwaysConnected", g_nSendMode);

   IR.GetDevice(g_sDriver).SetParameters(
   {
      Host: g_sHost, 
      Port: g_nPort, 
      Port1: g_nSerialPort1,
      Port2: g_nSerialPort2,
      SendMode: g_nSendMode,
      ScriptMode: g_nScriptMode,
      IrConfirm: g_nIrConfirm,
      DisableQueue: g_nDisableQueue,
      TrySendCount: g_nTrySendCount,
      BackGroundMode: g_nBackGroundMode
   }
   );
}

/**
   ???
   на входе    :  ???
   на выходе   :  ???
*/
function DisableQueue()
{
   g_nDisableQueue = 1;
   UpdateParameters();
}

/**
   ???
   на входе    :  ???
   на выходе   :  ???
*/
function EnableQueue()
{
   g_nDisableQueue = 0;
   UpdateParameters();
}


/**
   ???
   на входе    :  ???
   на выходе   :  ???
*/
function TrySendCount0()
{
   g_nTrySendCount = 0;
   UpdateParameters();
}

/**
   ???
   на входе    :  ???
   на выходе   :  ???
*/
function TrySendCount1()
{
   g_nTrySendCount = 1;
   UpdateParameters();
}

/**
   ???
   на входе    :  ???
   на выходе   :  ???
*/
function AlwaysConnected()
{
   g_nSendMode = 0;
   UpdateParameters();
}

/**
   ???
   на входе    :  ???
   на выходе   :  ???
*/
function ConnectWhenSending()
{
   g_nSendMode = 1;
   UpdateParameters();
}

IR.AddListener(IR.EVENT_ONLINE, IR.GetDevice(g_sDriver), function(id)
{
   if(id == gKramerConnectID)
   {
      var l_pDevice = IR.GetDevice(g_sDriver);
      
      if(l_pDevice)
      {
         ;
      }
   }
   //IR.Log("Online: " + id);
})

IR.AddListener(IR.EVENT_OFFLINE , IR.GetDevice(g_sDriver), function(id)
{
   //IR.Log("Offline: " + id);
}, this)

IR.AddListener(IR.EVENT_RECEIVE_DATA, IR.GetDevice(g_sDriver), function(text,id)
{
   IR.Log("Receive: " + id);
   
   if(id == gKramerConnectID)
   {
      var pos = 0;
      while((text.length - pos) / 4 > 0)
      {
         if(text[pos] == 0x41)
         {
            var a = 0;
            var b = 0;
            
            pos++;
            a = text[pos++] & 0xF;
            b = text[pos++] & 0xF;
            
            // получение количества
            var l_pDevice = IR.GetDevice(g_sDriver);
            var l_iFeedbacksCount = l_pDevice.GetFeedbacksCount();
            
            IR.Log("l_iFeedbacksCount = " + l_iFeedbacksCount);
            
            // обход всех
            for(var i = 0; i < l_iFeedbacksCount; i++)
            {
               // получение по индексу позиции
               var l_pFeedback = l_pDevice.GetFeedbackAtPos(i);
               if(l_pFeedback)
               {                 
                  if(l_pFeedback.data.length > 1)
                  {
                     if(l_pFeedback.data[1] == b && l_pFeedback.data[0] != a)
                        IR.SetVariable("Driver." + g_sDriver + "." + l_pFeedback.name, 0);
                        
                     if(l_pFeedback.data[1] == b && l_pFeedback.data[0] == a)
                        IR.SetVariable("Driver." + g_sDriver + "." + l_pFeedback.name, 1);
                  }
               }
            }
         } else
         {
            pos += 3;
         }   
         
         pos++;
      }
      IR.Log(text);
   }
});

IR.AddListener(IR.EVENT_CHANNEL_SET , IR.GetDevice(g_sDriver), function(name,value)
{
   /*
   IR.Log("EVENT_CHANNEL_SET: " + name);
   var l_pDevice = IR.GetDevice(g_sDriver);
   var l_pCommand = l_pDevice.GetCommandAtName(name);
   
   if(l_pCommand)
      l_pDevice.Send([
      parseInt(l_pCommand.data[0], 16),
      parseInt(l_pCommand.data[1], 16),
      parseInt(l_pCommand.data[2], 16),
      parseInt(l_pCommand.data[3], 16)],
      gKramerConnectID);
   */
});